# File: testATMediaFile_copy.py
# 
# Copyright (c) 2005 by Chris Miles
# Generator: manual - this couldn't be generated by AGX as it needs to
#     use ATMediaExample to perform the ATMediaFile tests.
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Chris Miles <miles.chris@gmail.com>'''
__docformat__ = 'plaintext'

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

import ATMFTestCase
from OFS.Image import File

#
# Base TestCase for ATMediaFile
#
from Testing import ZopeTestCase
from Products.PloneTestCase import PloneTestCase

ZopeTestCase.installProduct('Archetypes')
ZopeTestCase.installProduct('PortalTransforms', quiet=1)
ZopeTestCase.installProduct('MimetypesRegistry', quiet=1)
ZopeTestCase.installProduct('ATMediaFile')
ZopeTestCase.installProduct('ATMediaExample')	## Added manually...
# If the products's config includes DEPENDENCIES, install them too
try:
    from Products.ATMediaFile.config import DEPENDENCIES
except:
    DEPENDENCIES = []
for dependency in DEPENDENCIES:
    ZopeTestCase.installProduct(dependency)

#PRODUCTS = ('Archetypes', 'ATMediaFile')
PRODUCTS = ('Archetypes', 'ATMediaExample')

PloneTestCase.setupPloneSite(products=PRODUCTS)


class TestCopyFile(ATMFTestCase.ATMFTestCase):
    """ TestCase for ATMediaFile: copy & paste functionality.
    """

    def afterSetUp(self):
        self.art = self._addFileByFileUpload(self.folder, 'file',
                                             ATMFTestCase.FILENAME_TEXT)
	self.basepath = os.path.join( ATMFTestCase.BASE_PATH,
		PloneTestCase.default_user )
	self.path = os.path.join( self.basepath,
		ATMFTestCase.FILENAME_TEXT )
        cb = self.folder.manage_copyObjects([ATMFTestCase.FILENAME_TEXT])
        res = self.folder.manage_pasteObjects(cb)
        self.id_new = res[0]['new_id']
        self.path_new = os.path.join(self.basepath, self.id_new)
        self.art_new = getattr(self.folder, self.id_new, None)

    def testIdHasChanged(self):
        self.assertNotEqual(ATMFTestCase.FILENAME_TEXT, self.id_new)

    def testOldRemainsOnZODB(self):
        self.failUnless(ATMFTestCase.FILENAME_TEXT in self.folder.objectIds())

    def testOldRemainsOnFileSystem(self):
        self.failUnless(ATMFTestCase.FILENAME_TEXT in
                        os.listdir(self.basepath))

    def testNewPresentOnZODB(self):
        self.failUnless(self.id_new in self.folder.objectIds())

    def testNewPresentOnFileSystem(self):
        self.failUnless(self.id_new in os.listdir(self.basepath))

    def testPathChangedOnStorage(self):
        field = self.art.getField('file')
        field_new = self.art_new.getField('file')
        self.assertNotEqual(field.storage.getFilepath(self.art, 'file'),
                            field_new.storage.getFilepath(self.art_new, 'file'))

    def testSameContentOnZODB(self):
        file_obj1 = self.art.getFile()
        file_obj2 = self.art_new.getFile()
        self.assertEqual(file_obj1.data, file_obj2.data)
        self.assertNotEqual(file_obj1.filename, file_obj2.filename)

    def testSameContentOnFileSystem(self):
        self.assertEqual(open(self.path, 'r').read(),
                         open(self.path_new, 'r').read())


def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestCopyFile))
    return suite



if __name__ == '__main__':
    framework()


