# File: testATMediaFile_cut.py
# 
# Copyright (c) 2005 by Chris Miles
# Generator: manual - this couldn't be generated by AGX as it needs to
#     use ATMediaExample to perform the ATMediaFile tests.
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Chris Miles <miles.chris@gmail.com>'''
__docformat__ = 'plaintext'

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

import ATMFTestCase
from OFS.Image import File

#
# Base TestCase for ATMediaFile
#
from Testing import ZopeTestCase
from Products.PloneTestCase import PloneTestCase

ZopeTestCase.installProduct('Archetypes')
ZopeTestCase.installProduct('PortalTransforms', quiet=1)
ZopeTestCase.installProduct('MimetypesRegistry', quiet=1)
ZopeTestCase.installProduct('ATMediaFile')
ZopeTestCase.installProduct('ATMediaExample')	## Added manually...
# If the products's config includes DEPENDENCIES, install them too
try:
    from Products.ATMediaFile.config import DEPENDENCIES
except:
    DEPENDENCIES = []
for dependency in DEPENDENCIES:
    ZopeTestCase.installProduct(dependency)

#PRODUCTS = ('Archetypes', 'ATMediaFile')
PRODUCTS = ('Archetypes', 'ATMediaExample')

PloneTestCase.setupPloneSite(products=PRODUCTS)


class TestCutFile(ATMFTestCase.ATMFTestCase):
    """ TestCase for ATMediaFile: cut & paste functionality.
    """

    def afterSetUp(self):
        self.art = self._addFileByFileUpload(self.folder, 'file',
                                             ATMFTestCase.FILENAME_TEXT)
	self.basepath = os.path.join( ATMFTestCase.BASE_PATH,
		PloneTestCase.default_user )
	self.path = os.path.join( self.basepath,
		ATMFTestCase.FILENAME_TEXT )
        self.folder.invokeFactory('Folder', id='new_folder')
        self.new_folder = getattr(self.folder, 'new_folder', None)
        cb = self.folder.manage_cutObjects([ATMFTestCase.FILENAME_TEXT])
        res = self.new_folder.manage_pasteObjects(cb)

    def testOldRemovedFromZODB(self):
        self.failIf(ATMFTestCase.FILENAME_TEXT in self.folder.objectIds())

    def testOldRemovedFromFileSystem(self):
        self.failIf(ATMFTestCase.FILENAME_TEXT in os.listdir(self.basepath))

    def testNewPresentOnZODB(self):
        self.failUnless(ATMFTestCase.FILENAME_TEXT in self.new_folder.objectIds())

    def testNewPresentOnFileSystem(self):
        new_folder_path = os.path.join(self.basepath, 'new_folder')
        self.failUnless(ATMFTestCase.FILENAME_TEXT in os.listdir(new_folder_path))

    def testPathChangedOnStorage(self):
        path = os.path.join(self.basepath, 'new_folder',
                            ATMFTestCase.FILENAME_TEXT)
        art = getattr(self.new_folder, ATMFTestCase.FILENAME_TEXT)
        field = art.getField('file')
        self.assertEqual(path, field.storage.getFilepath(art, 'file'))

    def testSameContentOnZODB(self):
	fp = open(ATMFTestCase.DATAPATH_TEXT, 'r')
	content = fp.read()
	fp.close()
        art = getattr(self.new_folder, ATMFTestCase.FILENAME_TEXT)
        file_obj = art.getFile()
        self.assertEqual(content, file_obj.data)

    def testSameContentOnFileSystem(self):
	fp = open(ATMFTestCase.DATAPATH_TEXT, 'r')
	content = fp.read()
	fp.close()
        path = os.path.join(self.basepath, 'new_folder',
                            ATMFTestCase.FILENAME_TEXT)
        self.assertEqual(content, open(path, 'r').read())


def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestCutFile))
    return suite



if __name__ == '__main__':
    framework()


