##################################################################################
#
#    Copyright (C) 2007 EngageMedia, All rights reserved.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##################################################################################

__author__  = '''Andy Nicholson'''
__docformat__ = 'plaintext'
__version__   = '$ Revision 0.0 $'[11:-2]

import zLOG
from zope.interface import implements
from zope.component import adapts

from Products.ATMediaFile.xmlrpc.interfaces import IObjectConstructor
from Products.ATContentTypes.interface.file import IATFile

from Products.CMFPlone.utils import _createObjectByType

class ObjectConstructorAdapter(object):
    """Implements the XMLRPC publishing on the ATMediaFile object """
    implements(IObjectConstructor)
    adapts(IATFile)

    def __init__(self,context):
    	# we are a trusted adapter
	# ie it is security-proxied
    	self.context = self.__parent__ = context

    def constructRelatedObject(self,type,dict):
	""" return some info about this object """
 	
	#create the associated type of file
	new_id = dict['id']
	new_title = dict['title']
        zLOG.LOG('ATMediaFile',zLOG.INFO,'Using %s as container for new object of type %s, using new id %s and title %s ' % (self.context.getId(), type, new_id, new_title))

        # first delete old object of same id -- this is a way we can make sure updates happen properly
        try:
        	self.context.manage_delObjects([new_id])
        except:
        	pass
        #try to make the new type in the choosen container
        self.context.invokeFactory(type,id=new_id,title=new_title)

        #get the new object back
        new_obj = getattr(self.context, new_id)

        # inject the content to the file and set the mimetype and filename
	if type is 'BitTorrentFile':
        	torrent_mimetype = "application/x-bittorrent"
		raw_file_data = dict['raw_file_data']

		## XXX
		# check self provides IATMediaFile
		#
                # ATMediaFile (and ATVideo) by default uses ExternalStorage
                # this file path is the path to the var/files/ ext storage area
                # inside the zope instance
		#
 
		# get the ExternalStorage object for this object
                file_ext_storage_obj = self.context.Schema()['file'].storage
                # get the filepath
                fn_ext_storage = file_ext_storage_obj.getFilepath(file_obj,'file')
		#finally, get just the basename of the a new fileaname using ".torrent" on the end
		torrent_filepath = os.path.basename(fn_ext_storage + ".torrent")
		#add the filedata to the new object
        	new_obj.setFile(raw_file_data, mimetype=torrent_mimetype, filename=torrent_filepath)

        # hide the the navTree
        new_obj.setExcludeFromNav(True)
        # relate the object with its corresponding new object
        self.context.setRelatedItems(new_obj)
        new_obj.reindexObject()

	return True

