from Products.Archetypes.Widget import SelectionWidget, TypesWidget, KeywordWidget
from Products.Archetypes.Registry import registerWidget

from AccessControl import ClassSecurityInfo

# 
# Customised Tag widget
# based on KeywordWidget

class TagKeywordWidget(KeywordWidget):
    _properties = TypesWidget._properties.copy()
    _properties.update({
        'macro' : "atvideo_widgets/tagkeyword",
        'size'  : 5,
        'vocab_source' : 'portal_catalog',
        'roleBasedAdd' : False,
        })

    security = ClassSecurityInfo()

registerWidget(TagKeywordWidget,
               title="Tag Keyword",
               description="Provides selection for choosing tags.",
               used_for=('Products.Archetypes.Field.LinesField',))


# 
# ContentLicensing widget
#

class ContentLicensingWidget(SelectionWidget):
    _properties = TypesWidget._properties.copy()
    _properties.update({
        'format': "flex", # possible values: flex, select, radio
        'macro' : "atvideo_widgets/contentlicensing_widget",
        })

    security = ClassSecurityInfo()

registerWidget(ContentLicensingWidget,
               title="Content Licensing",
               description="Provides selection for choosing a license.",
               used_for=('Products.Archetypes.Field.StringField',))

# 
# Duration widget
#

class TimeDurationWidget(TypesWidget):
    _properties = TypesWidget._properties.copy()
    _properties.update({
        'format': "", # 
        'macro' : "atvideo_widgets/duration",
        })

    security = ClassSecurityInfo()

registerWidget(ContentLicensingWidget,
               title="Content Licensing",
               description="Provides selection for choosing a license.",
               used_for=('Products.Archetypes.Field.StringField',))



#
#
# OLD widgets - based on PloneCreativeCommons product

#
# custom widgets to make CC license selection form elements
#  see ATVideo/skins/ATEngageVideo/widgets/ccNC.pt (ccND.pt)
# 
class ccNCSelectionWidget(SelectionWidget):
    _properties = TypesWidget._properties.copy()
    _properties.update({
        'format': "flex", # possible values: flex, select, radio
        'macro' : "atvideo_widgets/ccNC",
        })

    security = ClassSecurityInfo()

class ccNDSelectionWidget(SelectionWidget):
    _properties = TypesWidget._properties.copy()
    _properties.update({
        'format': "flex", # possible values: flex, select, radio
        'macro' : "atvideo_widgets/ccND",
        })

    security = ClassSecurityInfo()

registerWidget(ccNCSelectionWidget,
               title="Creative Commons Non Commerical",
               description="Provides selection box for choosing Non Commerical or not in Creative Commons License.",
               used_for=('Products.Archetypes.Field.StringField',))

registerWidget(ccNDSelectionWidget,
               title="Creative Commons No Derivations",
               description="Provides selection box for choosing No Derivations or not in Creative Commons License.",
               used_for=('Products.Archetypes.Field.StringField',))


