# -*- coding: utf-8 -*-
#
# File: video.py
#
# Copyright (c) 2006 by Nate Aune (Jazkarta), Andy Nicholson, Wolfgang Reutz
# Generator: ArchGenXML Version 1.5.0 svn/devel
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Nate Aune (Jazkarta) <natea@jazkarta.com>, Christof Haemmerle (nex9)
<reco@buero-newyork.com>, Chris Miles <chris@chrismiles.info>, Andy Nicholson
<andy@cat.org.au>, Wolfgang Reutz <wolfgang.reutz@vol.at>, Dave Fregon
<axxs@axxs.org>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.ATMediaFile.content.mediafile import ATMediaFile
from Products.ATVideo.interfaces.IVideoMetaData import IVideoMetaData
from Products.ATVideo.interfaces.content_markers import IATVideo
from Products.ATVideo.config import *
from zope.interface import implements
##code-section module-header #fill in your manual code here
# try:
#     from Products.LinguaPlone.public import *
# except:
#     from Products.Archetypes.public import *

#file manipulation
import os

import zLOG

##/code-section module-header

schema = Schema((

    #user uploaded thumbnail image for the image
    ImageField(
        name='thumbnailImage',
        schemata="step 3",
        widget=ImageWidget(
            label="Thumbnail Image",
            description="Upload a thumbnail image representing your video (320 x 240 pixels recommended size)",
            label_msgid='ATVideo_label_thumbnailImage',
            description_msgid='ATVideo_help_thumbnailImage',
            i18n_domain='ATVideo',
        ),
        languageIndependent=1,
        storage=AttributeStorage(),
        sizes={'small':(160,120),
               'medium':(200,200),
               'presentation':(300,300),
               'large':( 400,400)},
	#not used
        #allowable_content_types=('image/gif', 'image/jpeg','image/png')
	validators = ('isImageType'),
	index="FieldIndex:schema",
	index_method="hasThumbnailImage"
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

ATVideo_schema = getattr(ATMediaFile, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class ATVideo( ATMediaFile ):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(ATMediaFile,'__implements__',()),) + (IVideoMetaData,)

    implements( IATVideo )

    # This name appears in the 'add' box
    archetype_name = 'Video'

    meta_type = 'ATVideo'
    portal_type = 'ATVideo'
    allowed_content_types = [] + list(getattr(ATMediaFile, 'allowed_content_types', []))
    filter_content_types = 0
    global_allow = 1
    allow_discussion = False
    content_icon = 'video_icon.png'
    immediate_view = 'base_view'
    default_view = 'video_view'
    suppl_views = ()
    typeDescription = "Video"
    typeDescMsgId = 'description_edit_atvideo'

    _at_rename_after_creation = True

    schema = ATVideo_schema

    ##code-section class-header #fill in your manual code here

    #the cached thumbnail size on disk
    thumb_size = None

    ##/code-section class-header

    # Methods

    security.declarePublic('stream')
    def stream(self):
        """
        
        """
        
    # Methods from Interface IVideoMetaData

    security.declarePublic('getMetaDuration')
    def getMetaDuration(self):
        """
        
        """
        
    security.declarePublic('getMetaBitRate')
    def getMetaBitRate(self):
        """
        
        """
        
    security.declarePublic('getMetaCodec')
    def getMetaCodec(self):
        """
        
        """
        
    security.declarePublic('getMetaPublisher')
    def getMetaPublisher(self):
        """
        
        """
        
    security.declarePublic('setMetaPublisher')
    def setMetaPublisher(self):
        """
        
        """
        
    security.declarePublic('getMetaProductionCompany')
    def getMetaProductionCompany(self):
        """
        
        """
        
    security.declarePublic('setMetaProductionCompany')
    def setMetaProductionCompany(self):
        """
        
        """
        
    # Manually created methods
    security.declarePublic('hasThumbnailImage')
    def hasThumbnailImage(self):
    	if self.thumb_size is None:
		try:
	   		thumb_size_fs = self.Schema()['thumbnailImage'].get_size(self)
	   		if thumb_size_fs > 0:
				#cache it
				self.thumb_size = thumb_size_fs
	   			return True
	   		else:
				return False
        	except:
	   		return False
	else:
		#used cache version!
		return True

    def createTorrent(self):
	try:
	    #try to preferentially use the remote server method
	    #which downloads the entire media file, makes a metafile (.torrent) and seeds it
	    if (self.portal_atmediafiletool.getEnable_remote_bittorrent()):
		zLOG.LOG('ATVideo', zLOG.INFO, 'Using atmediafiletool to do remote torrent creation and seeding')

	    	self.portal_atmediafiletool.createRemoteTorrentFile(self)
	    else:
	    	#just try to locally make a .torrent file, assuming a local seeder / tracker process is running.
            	if (self.portal_atmediafiletool.getEnable_bittorrent()):
			zLOG.LOG('ATVideo', zLOG.INFO, 'Using atmediafiletool to do local torrent creation')

                	self.portal_atmediafiletool.createTorrentFile(self)
        except:
            raise


    security.declarePrivate('manage_afterAdd')
    def manage_afterAdd(self, item, container):
        """Re-generate torrent file!
        """
        ATMediaFile.manage_afterAdd(self, item, container)
	zLOG.LOG('ATVideo', zLOG.INFO, 'manage_afterAdd')
	# XXX why is this here, commented out ?
	#self.createTorrent()

    security.declarePrivate('manage_beforeDelete')
    def manage_beforeDelete(self, item, container):
        """delete the torrent object and the torrent file!
        """
	zLOG.LOG('ATVideo', zLOG.INFO, 'deleting the torrent file!')
	objs = self.getRelatedItems()
	related_id = None
        for v in objs:
                #test v is a BitTorrentFile, use the first one we find
                zLOG.LOG('ATVideo', zLOG.INFO,'manage_beforeDelete: found related item %s' % v.getTypeInfo().getId())
		if v.getTypeInfo().getId()=='BitTorrentFile':
			related_id = v.getId()
			break

	if related_id is not None:
		try:
			self.manage_delObjects([related_id])
		except:
			#hmm
			pass
        ATMediaFile.manage_beforeDelete(self, item, container)

    def processForm(self, data=1, metadata=0, REQUEST=None, values=None):
        """Process the schema looking for data in the form"""
        self._processForm(data=data, metadata=metadata,
                          REQUEST=REQUEST, values=values)

        self.createTorrent()
 
    def getStreamPath(self, file_id=""):
        """ return the stream path for file_id """
        if not file_id:
            return ""
        
        # hardcode this until we implement media_server in the video_tool or media_tool    
        media_server = ""
        relative_path = ""
        
        if media_server:
            path = relative_path + '/' + file_id
        else:
            path = self.absolute_url()
        return path



registerType(ATVideo, PROJECTNAME)
# end of class ATVideo

##code-section module-footer #fill in your manual code here
##/code-section module-footer



