from zLOG import LOG, INFO
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.WorkflowCore import WorkflowException

temp_permissions = [
    'Add Documents, Images, and Files', 'Add portal content',
    'Delete objects'
]

# thanks to http://www.mxm.dk/Members/maxm for this, you can locate the
# original and howto at : http://www.mxm.dk/products/public/dmcs

# When a Member is added, it is done with the rights of an Anonymous 
# user. To add content to the folder, the anonymous user must 
# temporarily be granted permissions to add these content types.
#
# Basically you need to add permissions to add all the content types you 
# want copied from the default member folder.

def notifyMemberAreaCreated(container,context):

    # this is the plone folder that holds the default member content
    default_member_content = getattr(container, 'default_member_content', None)

    memb = container.portal_membership.getAuthenticatedMember()
    member_id = memb.getId()
    LOG('ATVideo', INFO, "notifyMemberAreaCreated,found it - member is %s " % member_id) 

    anonymous_role = ['Anonymous']
    for perm in temp_permissions:
        context.manage_permission(perm, anonymous_role, acquire=1)

    # if the default_member_content folder has an index html we want 
    # to overwrite the default one. So it needs to be deleted
    idx = 'index_html'
    member_has_idx = idx in context.objectIds()
    default_has_idx = idx in default_member_content.objectIds()
    if default_has_idx and member_has_idx:
        try: 
        	context.manage_delObjects(idx)
	except:
		pass
    
    # here we do the copying
    copy_ids = default_member_content.objectIds()
    id_filter = ['.personal']
    copy_ids = [id for id in copy_ids if id not in id_filter]
    objects = default_member_content.manage_copyObjects(copy_ids)
    context.manage_pasteObjects(objects)

    
    # for some reason the copied index_html will get the id 
    # 'copy_of_index_html' even though there shouldn't be one, so we 
    # need to rename it back to index_html
    
    copy_idx = 'copy_of_index_html'
    if copy_idx in context.objectIds():
        context.manage_renameObject(copy_idx, idx)

    # Here we delete those temporary permissions again
    for perm in temp_permissions:
        context.manage_permission(perm, [], acquire=1)
    
    context.manage_fixupOwnershipAfterAdd()

    # Grant Ownership and Owner role to Member, for each of the new objects pasted
    exclude_filter = [ 'syndication_information' ]
    def updateCreatorAndOwnership(object):
        ids_to_update = [ o for o in object.objectIds() if o not in exclude_filter ]
	for o in ids_to_update:
   	    LOG('ATVideo',INFO,'notifyMemberAreaCreated : object is %s ' % o)
	    obj = getattr(object, o)
    	    LOG('ATVideo',INFO,'object type is %s, creators %s ' %  (obj.getTypeInfo().getId(),obj.Creators()))
	    obj.setCreators([member_id])
	    try:
            	container.plone_utils.changeOwnershipOf ( obj, member_id, 1) 
	    except KeyError:
	    	#special case, we must be using a user outside of this plone site, 
		#eg an admin user defined in a higher level
		pass
	    updateCreatorAndOwnership(obj)
    
    #publish the members folder, videos , news and events subfolders
    workflow = getToolByName(container,'portal_workflow')
    workflow.doActionFor(context,'publish')
    for pubobj in context.objectIds():
    	#try:
	LOG('ATVideo',INFO,'publishing %s ' % pubobj)
	obj2 = getattr(context, pubobj)
   	workflow.doActionFor(obj2, 'publish')
    	#except WorkflowException:
	#	pass

    #run the recursive update creator and ownership
    updateCreatorAndOwnership(context)
