
import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Products.CMFPlone.tests import PloneTestCase
from unittest import TestSuite, makeSuite
from Testing import ZopeTestCase
from Testing.ZopeTestCase import user_name
from AccessControl import Unauthorized

ZopeTestCase.installProduct('ContentLicensing')

PloneTestCase.setupPloneSite(products=('ContentLicensing',))

class testContentLicensing(PloneTestCase.PloneTestCase):

    def testRecursive(self):
        self.setRoles(['Manager'])
        pcl = self.portal.portal_contentlicensing
        self.portal.invokeFactory('Folder','folder1')
        folder1 = getattr(self.portal,'folder1')
        folder1.setTitle('Test Folder 01')
        folder1.invokeFactory('Document','doc1')
        doc1 = getattr(folder1,'doc1')
        doc1.setTitle('Test Document 01')
        doc1.setCreators('Piotr Tchaikovsky\nWinter Daydreams\nLon Pathetique\nGuido Van Rossum')
        doc1.setText('lorem ipsum blah blah blah')
        folder1.invokeFactory('Image','img1')
        img1 = getattr(folder1,'img1')
        img1.setTitle('Test Image 01')

        gnu_license = pcl.license_gnuFree
        folder1.REQUEST['license'] = gnu_license[0]
        folder1.REQUEST['license_cc_name'] = gnu_license[1]
        folder1.REQUEST['recurse_cc_url'] = gnu_license[2]
        folder1.REQUEST['recurse_cc_button'] = gnu_license[3]
        folder1.content_edit_recurse(recurse_folders=1)

        folder1_lic = pcl.getLicenseAndHolderFromObject(folder1)
        doc1_lic = pcl.getLicenseAndHolderFromObject(doc1)
        img1_lic = pcl.getLicenseAndHolderFromObject(img1)
        assert(folder1_lic == doc1_lic)
        assert (folder1_lic == img1_lic)
        
    def testNotRecursive(self):
        self.setRoles(['Manager'])
        pcl = self.portal.portal_contentlicensing
        self.portal.invokeFactory('Folder','folder1')
        folder1 = getattr(self.portal,'folder1')
        folder1.setTitle('Test Folder 01')
        folder1.invokeFactory('Document','doc1')
        doc1 = getattr(folder1,'doc1')
        doc1.setTitle('Test Document 01')
        doc1.setCreators('Piotr Tchaikovsky\nWinter Daydreams\nLon Pathetique\nGuido Van Rossum')
        doc1.setText('lorem ipsum blah blah blah')
        folder1.invokeFactory('Image','img1')
        img1 = getattr(folder1,'img1')
        img1.setTitle('Test Image 01')

        gnu_license = pcl.license_gnuFree
        folder1.REQUEST['license'] = gnu_license[0]
        folder1.REQUEST['license_cc_name'] = gnu_license[1]
        folder1.REQUEST['recurse_cc_url'] = gnu_license[2]
        folder1.REQUEST['recurse_cc_button'] = gnu_license[3]
        folder1.content_edit_recurse(recurse_folders=0)

        folder1_lic = pcl.getLicenseAndHolderFromObject(folder1)
        doc1_lic = pcl.getLicenseAndHolderFromObject(doc1)
        img1_lic = pcl.getLicenseAndHolderFromObject(img1)
        assert(folder1_lic != doc1_lic)
        assert(folder1_lic != img1_lic)


def test_suite():
    suite = TestSuite()
    suite.addTest(makeSuite(testContentLicensing))
    return suite

if __name__ == '__main__':
    framework()
