# -*- coding: utf-8 -*-

from zope import i18n
_ = i18n.MessageIDFactory("plumi")

from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.CMFCorePermissions import ManagePortal
from Products.CMFCore.WorkflowCore import WorkflowException
from Products.CMFPlone.migrations.migration_util import safeEditProperty

from Products.ExternalMethod.ExternalMethod import ExternalMethod
from Products.Portletification.interfaces import IPortletifiable

from Products import PlumiSkin
from Products.PlumiSkin import skin_globals
from Products.PlumiSkin.config import STYLESHEETS, USER, UPDATE_USER_LISTED_IN_SEARCHES, DELETE_EXISTING_CALLOUT_FOLDER, CALLOUT_FOLDER, VIDEO_FOLDER, NEWS_FOLDER, EVENTS_FOLDER
from Products.PlumiSkin.config import HOMEPAGE as plumi_homepage

from Products.ATVideo.config import GENRE_FOLDER, CATEGORIES_FOLDER, COUNTRIES_FOLDER, TOPLEVEL_FOLDER, SUBMISSIONS_FOLDER,DEFAULT_MB_FLDR

from cStringIO import StringIO
import string
import os
import md5, time
from DateTime import DateTime

#skin layer names
plumi_overrides    = ("plumi_qplonecomments",)
plumi_skin_folders = ("plumi_images",
                      "plumi_icons",
                      "plumi_scripts",
                      "plumi_styles",
                      "plumi_templates"
                      )

# The list of skin folders to register
skinFolders = plumi_skin_folders + plumi_overrides

#New Skin name
skinName = 'PlumiSkin'
#leave as Plone Default til now.
baseSkin = 'Plone Default'

# setupSupplViews, removeSupplyViews
# adapted from http://plone.org/products/diyplonestyle/issues/8
# andy

SUPPL_VIEWS = {
     'Topic' : ('video_listing_view',), #smart folder
     'Folder' : ('video_listing_view',),
          } 

def setupSupplViews(self, out, dict):
    # add the views for the defined content type(s)
    pt_tool = getToolByName(self, 'portal_types')
    for ptype, views in dict.items():
        FTI = getattr(pt_tool,ptype)
        FTI.view_methods = FTI.view_methods + views
        print >> out, "Added supplementary views to '%s' in portal_types." % ptype

def removeSupplViews(self, out, dict):
    # remove the views for the defined content type(s)
    pt_tool = getToolByName(self, 'portal_types')
    for ptype, views in dict.items():
        FTI = getattr(pt_tool,ptype)
        view_methods = list(FTI.view_methods)
        views_to_keep = []
        for view in view_methods:
            if view not in views:
                views_to_keep.append(view)
    
        FTI.view_methods = tuple(views_to_keep)
        print >> out, "Removed supplementary views from '%s' in portal_types." % ptype 

def setupSkin (self, out):
    skinsTool = getToolByName (self, 'portal_skins')
    
    # Add directory views

    addDirectoryViews (skinsTool, 'skins', skin_globals)
    out.write ("Added directory views to portal_skins.\n")
       
    # Only add if the skin doesn't already exist
    #if skinName not in skinsTool.getSkinSelections():
    if True:

        # Get the skin paths of the base skin and convert to an array
        path = skinsTool.getSkinPath (baseSkin)
        path = map (string.strip, string.split (path,','))
        
        # Add our own skin folders to this path, under 'custom'
        for skinFolder in skinFolders:
            if skinFolder not in path:
                try: 
                    path.insert (path.index ('custom') + 1, skinFolder)
                except ValueError:
                    path.append (skinFolder)
    
        # Add our skin
        path = string.join (path, ', ')    
	#make it the default, and test it
        skinsTool.addSkinSelection (skinName, path,make_default=1,test=1)

    else:
        out.write ('Skin already exists, leaving it alone\n')
       

def removeSkin (self, out):

    skinsTool = getToolByName (self, 'portal_skins')
    
    # Delete the property which holds the skin
    if skinName in skinsTool.getSkinSelections ():
        skinsTool.manage_skinLayers (del_skin = 1, chosen = (skinName,))
   
    #update the default skin!
    #XXX probably shld use portal_utils.setDefaultSkin(_)
    skinsTool.default_skin = baseSkin 

def enableqRSS2(self,folder,out):
    #from Products.qRSS2Syndication.utils import setupRSS2Types
    #copied from ATVideo AppInstall

    out.write('doing qRSS2 setup with %s\n' % folder.Title())
    portal_syn = getToolByName(self,'portal_syndication',None)
    try:
        portal_syn.enableSyndication(folder)
    except:
        pass
    syInfo =  getattr(folder, 'syndication_information', None)
    types2Syn=['ATVideo','ATEngageVideo','Call Out']
    only_published = 1
    include_subfolders = 1
    articles_number = 20
    enable_itunes = 1
    itunes_image_url = ''
    itunes_explicit = 0
    if syInfo is not None:
        out.write('doing actual setup with syndication_information object\n')
        syInfo.rss2_types = list(types2Syn)
        syInfo.only_published = only_published
        syInfo.include_subfolders = include_subfolders
        syInfo.max_items = articles_number
        syInfo.enable_itunes = enable_itunes
        syInfo.itunes_image_url = itunes_image_url
        syInfo.itunes_explicit = itunes_explicit
    out.write('syndication rss2 setup done.\n')


def installUser(self,out):
    """We create a user for Plumi.
    It will first try to delete the user with the same id
    and then register a new one with all the infos.
    Read config.py for more informations
    """
    mt = getToolByName(self,'portal_membership')
    # If you are going to have an installed password, at least make it pseduo-random
    password = md5.md5(str(time.time())).hexdigest()[:12]
   
    try:
        mt.getMembersFolder()._delObject(USER['id'])
    except:
        # We don't really want to silence it all, do we ?
        pass
   
    mt.addMember(USER['id'], password, ['Member','Manager'], [])
    member = mt.getMemberById(USER['id'])
    member.setMemberProperties({'fullname': USER['fullname'],
                                'email': USER['email'],
                                'last_login_time': DateTime('2006-06-01'),})

    # Checks for Taxonomy objects installed by ATVideo (ATEngageVideo)
    # take ownership of them by the Plumi user, update layouts
    #
    if hasattr(self,TOPLEVEL_FOLDER):
        out.write('Changing ownership of taxonomy folder and sub-folders!\n')
        toplvl_fldr = getattr(self,TOPLEVEL_FOLDER)
        publishObjectandOwnership(self, toplvl_fldr ,USER['id'])
        idstochange = [  GENRE_FOLDER, CATEGORIES_FOLDER, COUNTRIES_FOLDER, SUBMISSIONS_FOLDER ]
        for x in idstochange:
            obj = getattr(toplvl_fldr,x,None)
	    if obj is not None:
		#change ownership of smart folder
            	publishObjectandOwnership(self,obj,USER['id'])
            	#update the children objects too
            	ids_to_update = [ sub_obj for sub_obj in obj.objectIds() ]
            	for y in ids_to_update:
                	sub_obj = getattr(obj,y)
                	publishObjectandOwnership(self,sub_obj,USER['id'])
			#update the layout 
			# NOT SUBMISSIONS_FOLDER! only if in a video categories listing
			if x in [GENRE_FOLDER, CATEGORIES_FOLDER, COUNTRIES_FOLDER]:
				sub_obj.setLayout('video_listing_view')
			else:
				sub_obj.setLayout('folder_listing')
    else:
	out.write('No top level taxonomy folder found!\n')

def publishObjectandOwnership(self, obj,user_id):
    """This method sets the given user as creator of the
    given object. Then, it tries to trigger the workflow
    transition to publish it.
    """
    obj.setCreators(user_id)
    self.plone_utils.changeOwnershipOf(obj, user_id, 1)
    
    try:
        # Try to publish it straight away
        workflow = getToolByName(self,'portal_workflow')
        workflow.doActionFor(obj, 'publish')
    except WorkflowException:
        pass

def installIndex (self, out):
    """The front page, @@featured_videos_homepage, contains
    links to 'featured-videos' which is a smart folder containing
    all the videos with keyword 'featured' and 'lastestvideos'
    which is a smart folder of the latest videos. this method will
    simply install them.
    """

    # Items to deploy on install.
    items = (dict(id      = 'featured-videos',
                  title   = _(u'Featured Videos'),
                  desc    = _(u'Videos featured by the Plumi team'),
                  layout  = "video_listing_view",
                  exclude = True),
             
             dict(id      = 'latestvideos',
                  title   = _(u'Latest Videos'),
                  desc    = _(u'Latest videos on Plumi'),
                  layout  = "video_listing_view",
                  exclude = False))

    # Items creation
    for item in items:
   	try:
            self.manage_delObjects([item['id']])
   	except:
            ## This is nasty to silence it all
            pass

        # We create the element
   	self.invokeFactory('Topic',
                           id = item['id'],
                           title = item['title'],
                           description = item['desc'].translate({}))

        # We change its ownership and wf status
   	fv = getattr(self, item['id'])
   	publishObjectandOwnership(self, fv,USER['id'])
        
   	# Filter results to ATEngageVideo
        # Have to use the name of the Title (and ATEngageVideo will be re-named by configATEngageVideo to Video!)
   	# this will actually use ALL objects with title 'Video', which means atm, ATEngageVideo and ATVideo
   	type_criterion = fv.addCriterion('Type', 'ATPortalTypeCriterion')
   	type_criterion.setValue("Video")

   	# Filter results to this 'keyword' field, the kw being 'featured'
	if item['id'] is 'featured-videos':
            type_criterion = fv.addCriterion('Subject', 'ATSimpleStringCriterion')
            type_criterion.setValue('featured')
            
	# Sort on reverse publication date order
	sort_crit = fv.addCriterion('getFirstPublishedTransitionTime',"ATSortCriterion")
   	sort_crit.setReversed(True) 

   	## add criteria for showing only published videos
   	state_crit = fv.addCriterion('review_state', 'ATSimpleStringCriterion')
   	state_crit.setValue('published')
  
	if item['exclude'] is True: 
            fv.setExcludeFromNav(True)

        if item['layout'] is not None:
            fv.setLayout(item['layout'])

        fv.reindexObject()

def ChangeSiteNewsEventsLayout(self,out):
    """Changes the layout of the 'events' folder in the
    plone root. No needs to change anything tp 'news' as
    it's already set on 'summary view' by default.
    """
    # We need to check if the folder is here.
    # It might not be as people tend to delete it.
    events = getattr(self, "events", None)
    if events:
        events.setLayout('folder_summary_view')
        return True
    return False


def createNewsAndEventsFolder(self, out):
    try:
        self.manage_delObjects('news_and_events')
    except:
        pass

    # Creation of the news and events smart folder
    self.invokeFactory('Topic',
                       id = 'news_and_events',
                       title = _(u'News and Events'),
                       description = _(u'Collection of latest News '
                                       u'and Events').translate({}))
    
    fldr = getattr(self,'news_and_events')
    type_criterion = fldr.addCriterion('Type', 'ATPortalTypeCriterion' )
    type_criterion.setValue(('News Item','Event'))
    state_crit = fldr.addCriterion('review_state', 'ATSimpleStringCriterion')
    state_crit.setValue('published')
    #sort on reverse date order
    sort_crit = fldr.addCriterion('created',"ATSortCriterion")
    sort_crit.setReversed(True)
    #set default folder view
    fldr.setLayout('folder_summary_view')
    fldr.setExcludeFromNav(True)
    fldr.reindexObject()
    #publish it
    workflow = getToolByName(self,'portal_workflow')
    workflow.doActionFor(self.news_and_events, 'publish')

    out.write('News and Events Smart folder created\n')

def configureMembersNewsEventsFolders(self,out):
    #publish them
    workflow = getToolByName(self,'portal_workflow')
    try:
        workflow.doActionFor(self.Members, 'publish')
        workflow.doActionFor(self.news, 'publish')
        workflow.doActionFor(self.events, 'publish')
    except WorkflowException:
        #workaround for already published!
	pass

def addDefaultMemberSkeleton(self, out):
    """
    Create a default Member Skeleton folder and sub-folders on installation
    """
    try:
        # Remove existing instance if there is one
    	self.manage_delObjects([DEFAULT_MB_FLDR])
    except:
    	pass  
    self.invokeFactory('Folder', id=DEFAULT_MB_FLDR, title='Default Member Folder')
    default_member_folder = getattr(self, DEFAULT_MB_FLDR )
    #make the sub folders
    default_member_folder.invokeFactory('Callout Folder',id=CALLOUT_FOLDER['id'], title=CALLOUT_FOLDER['title'])
    default_member_folder.invokeFactory('ATEngageVideoFolder',
            id=VIDEO_FOLDER['id'], title=VIDEO_FOLDER['title'])
    default_member_folder.invokeFactory('Folder', id=NEWS_FOLDER['id'], title=NEWS_FOLDER['title'])
    default_member_folder.invokeFactory('Folder', id=EVENTS_FOLDER['id'], title=EVENTS_FOLDER['title'])
    ## If your change these, esp. if you add new folders, objects etc, make sure you
    # add a migration path  in migrateExistingMembers

    #excude it from the nav
    default_member_folder.setExcludeFromNav(True)

    #syndication turned on for the video folder by default
    #this is using qrss2syndication
    video_fldr =  getattr(default_member_folder, VIDEO_FOLDER['id'])
    video_fldr.setLayout('video_listing_view')
    enableqRSS2(self, video_fldr , out)
    #set default layout
    default_member_folder.news.setLayout('folder_summary_view')
    default_member_folder.events.setLayout('folder_summary_view')

    subs_folder =  getattr(default_member_folder, CALLOUT_FOLDER['id'])
    enableqRSS2(self, subs_folder , out)

    out.write("Created %s in Plone with Skeleton files for Member folders\n" % (DEFAULT_MB_FLDR ))


def migrateExistingMembers(self,out):
    """ Migrate any exisiting Members - ie update views on objects, update for new objs/folders in home folder
    """
    #start MEMBER MIGRATION

    putil =  getToolByName(self, 'plone_utils') 
    # migrate old Members
    for m in self.portal_membership.listMembers():
   	out.write("\nMigrating %s, id is %s\n " % (m.getUserName(),m.id))

   	user_id = m.id

	#1. Make sure users are listed - there was a bug on the custom personalise form.
	#revert member property listed, if not set (which means show up in the search listings)
   	if UPDATE_USER_LISTED_IN_SEARCHES and m.getProperty('listed') is not 1:
        	out.write(" not in searches..")
        	m.setMemberProperties({'listed':1})
	#
	#2. Creating 'callouts' Folder if not present.
        userfld = self.portal_membership.getHomeFolder(user_id)
   	if userfld is None:
        	out.write(" user doesnt have a Members folder!!\n")
        	continue
   	out.write(" user has in folder the following ids .. %s"% userfld.objectIds())

	callout_fld_id = CALLOUT_FOLDER['id']
	#lets delete the callout folder !
	# This is for use during development/testing only.
	#since we dont want to delete existing folders in production..
	if DELETE_EXISTING_CALLOUT_FOLDER:
		try:
		  userfld.manage_delObjects(callout_fld_id)
		except:
		  pass	

	#get the pre-existing Callouts folder
   	callout = getattr(userfld,callout_fld_id,None)
   	if callout is None:
		#if this Member doesnt have one, create it for them
       		userfld.invokeFactory('Callout Folder',id=callout_fld_id,title=CALLOUT_FOLDER['title'])
        	out.write(" constructed Callouts folder")
        	callout = getattr(userfld,callout_fld_id)
   	else:
        	out.write(" callout is %s\n "% callout.Title())
	#publish it,make it created by the user, and change the ownership to the user
	publishObjectandOwnership(self,callout,user_id)

        #3. Update members news, events folder layout
	news = getattr(userfld,NEWS_FOLDER['id'],None)
	if news is not None:
        	news.setLayout('folder_summary_view')
	events = getattr(userfld,EVENTS_FOLDER['id'],None)
	if events is not None:
        	events.setLayout('folder_summary_view')
	videos = getattr(userfld,VIDEO_FOLDER['id'],None)
	if videos is not None:
        	videos.setLayout('video_listing_view')



    out.write("\nFinished old members migration.\n")
    #end MEMBER MIGRATION


def insertContentIntoBlankDocuments(self,out):
   out.write('FIXME!!')
   #XXX TODO simple scheme to grab default content for all new blank documents

def installActionProviders(self, out):
   portal_actions = getToolByName(self,'portal_actions')
   #review list action if your a manager
   try:
	portal_actions.deleteActions(['review_list'])
   except:
	pass
   portal_actions.addAction( id='review_list'
                                    , name='Review List'
                                    , action='string:${portal_url}/full_review_list'
                                    , condition='python:1'
                                    , permission=('Manage portal')
                                    , category='portal_tabs'
                                    , visible=1
                                    ) 
   #show the add to favourites action by default
   portal_actions.getActionObject('document_actions/addtofavorites').edit(visible=1)
   #make some actions invisible.
   portal_actions.getActionObject('document_actions/full_screen').edit(visible=0)
   portal_actions.getActionObject('document_actions/print').edit(visible=0)


   #five new portal tab actions and their default blank ATDocuments
   actions_details = [ ('about-us','About us'),
			('contact-info','Contact'),
			('help-and-tutorials','Help'),
			('support-us','Support Us'),
			('get-involved','Get Involved')
		     ]	
   for a in actions_details:
        try:
		portal_actions.deleteActions(a[0])
	except:
		pass
   	portal_actions.addAction( id=a[0]
                                    , name=a[1]
                                    , action='string:${portal_url}/%s' % a[0]
                                    , condition='python:1'
                                    , permission=('View')
                                    , category='portal_tabs'
                                    , visible=1
                                    ) 
	#try:
	#	self.manage_delObjects([a[0]])
	#except:
	#	pass

    	#make the empty file!
        #but only if they dont already exist
	if not a[0] == 'contact-info' and getattr(self,a[0],None) == None:
    		self.invokeFactory('Document', a[0])
        	new_obj = getattr(self,a[0])
		publishObjectandOwnership(self,new_obj,USER['id'])
		new_obj.setExcludeFromNav(True)
		new_obj.reindexObject()
		out.write(' made %s an action called %s and an empty file\n ' % (a[0], a[1]))

   #make a links document , editorial document
   #but only if they dont already exist
   new_docs = [ ('editorial-policy','Editorial Policy') ]
   for d in new_docs :
	if getattr(self,d[0],None) == None:
   	#try:
	#	self.manage_delObjects(d[0])
   	#except:
	#	pass
   		self.invokeFactory('Document', d[0], title=d[1])
   		new_obj = getattr(self,d[0])
		publishObjectandOwnership(self,new_obj,USER['id'])

   #set the portal_tabs navigation section to NOT show folder items *like Members, news, events*
   self.portal_properties.site_properties.disable_folder_sections = True

   # turn off the top level 'home' link in portlet_navigation
   self.portal_properties.navtree_properties.includeTop = False
   
   #linksobj = getattr(self,'links',None)
   #if linksobj != None:
   #	linksobj.setExcludeFromNav(True)

   out.write('added action providers!\n')
       
def updateSlots(self,out):
    """ 
    Updates our slots to be using the custom portlets
    """
    portal=getToolByName(self,'portal_url').getPortalObject()
    our_slots = [	
			'here/portlet_publish/macros/portlet',
			'here/portlet_browse/macros/portlet',
			'here/portlet_navigation/macros/portlet',
			#commented out some more specific portlets
			#these portlets need org. specific customisations before turning on
   			#'here/portlet_video/macros/portlet',
   			#'here/portlet_mailinglist/macros/portlet',
   			#'here/portlet_donate/macros/portlet',
		]
    portal.left_slots = our_slots
    portal.right_slots = [
			 #'here/portlet_tag_cloud_explorer/macros/portlet',
			 'here/render_portletification/macros/right',
 			 'here/portlet_news/macros/portlet',
                         'here/portlet_events/macros/portlet',
			 'here/portlet_recent_callouts/macros/portlet',
                         'here/portlet_recent_comments/macros/portlet',
			 ]
    out.write('updated the left and right slots\n')

def addCustomCSS(self):
    """ Register our custom CSS with the css tool """
    try:
        portal_css = getToolByName(self, 'portal_css')
        for stylesheet in STYLESHEETS:
            try:
                portal_css.unregisterResource(stylesheet['id'])
            except:
                pass
            defaults = {'id': '',
            'enabled': True}
            defaults.update(stylesheet)
            portal_css.manage_addStylesheet(**defaults)
    except:
        # No portal_css registry
        pass

def installMembersPublishEvents(self,out):
    wf_tool = getToolByName(self, 'portal_workflow')
    try:
        wf_tool.setChainForPortalTypes(('Event',), chain='plone_workflow')
        out.write('Events set to the plone_workflow, Members can publish events directly\n')
    except:
        out.write('Failed setting the Events to the plone_workflow\n')

def changeCalendarSiteProperties(self,out):
     self.portal_properties.site_properties.manage_changeProperties( calendar_starting_year='1960')

def installMemberPreferences(self, out):
    """turn on Kupu by default"""
    md=getToolByName(self, 'portal_memberdata')
    if hasattr(md,'wysiwyg_editor'):
        safeEditProperty(md, 'wysiwyg_editor', 'Kupu', 'string')
    out.write('Kupu enabled by default for new users\n')

def installWorkflowScripts(self,out):
        """Install workflow scripts on plone_workflow."""

        workflow_tool = getToolByName(self, 'portal_workflow')

        plone_workflow = workflow_tool.plone_workflow

        wf_script_directory_path_list = PlumiSkin.__path__
        wf_script_directory_path = os.path.join(
            wf_script_directory_path_list[0],
            'wf_scripts'
            )
       
        all_files = os.listdir(wf_script_directory_path)
        scripts = []
        for each in all_files:
            each_list = each.split('.')
            if len(each_list) == 2:
                if each_list[1] == 'py':
                    scripts.append(each_list[0])

        scripts_repository_list = [plone_workflow.scripts, ]
        for eachScriptRepository in scripts_repository_list:

            existing_scripts = eachScriptRepository.objectIds()
            for each in scripts:
	    	script_path = wf_script_directory_path + '/' + each + '.py'
	    	script_file = open(script_path)
	    	script_content = script_file.read()
	    	script_file.close()
                if each not in existing_scripts:
		    eachScriptRepository.manage_addProduct['PythonScripts'].manage_addPythonScript(each)
	    	script_object = getattr(eachScriptRepository, each)
	    	script_object.write(script_content)
		#add a proxy role
		script_object._proxy_roles = ('Manager',)
		print >> out, 'Script %s created for %s ' % (each, eachScriptRepository)

        publish_transition = getattr(plone_workflow.transitions,
                                'publish',
                                None)
        publish_transition.after_script_name = 'inform_owners'
        out.write("Publish transition 'inform_owners' installed.\n")
        
        submit_transition = getattr(plone_workflow.transitions,
                                'submit',
                                None)
        submit_transition.after_script_name = 'inform_reviewers'
        out.write("Submit transition 'inform_reviewers' installed.\n")


def changePloneLayout(portal, out):
    """Changes the base layout of Plone to the wanted template/view"""

    ptypes = getToolByName(portal, "portal_types", None)
    if ptypes is None:
        raise NotImplementedError("No portal types tool found. "
                                  "This should never happen.")

    plone = ptypes.get("Plone Site", None)
    if plone is None:
        raise NotImplementedError("No Plone Site FTI found. "
                                  "This should never happen.")
    
    options = list(plone.getProperty("view_methods"))
    selectable = list(portal.getProperty("selectable_views"))
    current = plone.getProperty("default_view")
    layout = portal.getProperty("layout")

    plumi_homepage = "featured_videos_homepage"

    if layout and layout is not plumi_homepage:
        portal.manage_changeProperties(**{"layout" : plumi_homepage})
    
    if plumi_homepage not in options:
        options.append(plumi_homepage)
        plone.manage_changeProperties(**{"view_methods" : options})
        out.write("Plumi Homepage option added to Plone Site FTI views")

    if plumi_homepage not in selectable:
        selectable.append(plumi_homepage)
        portal.manage_changeProperties(**{"selectable_views" : selectable})
        out.write("Plumi Homepage option added to the portal properties")
        
    if plumi_homepage is not current:
        plone.setLayout(plumi_homepage)
        plone.manage_changeProperties(**{"default_view" : plumi_homepage})
        out.write("Plumi Homepage is now the portal's default view")


def restorePloneLayout(portal, out):
    """Restore the base layout of Plone"""

    ptypes = getToolByName(portal, "portal_types", None)
    if ptypes is None:
        raise NotImplementedError("No portal types tool found. "
                                  "This should never happen.")

    plone = ptypes.get("Plone Site", None)
    if plone is None:
        raise NotImplementedError("No Plone Site FTI found. "
                                  "This should never happen.")
    
    options = list(plone.getProperty("view_methods"))
    current = plone.getProperty("default_view")
    selectable = list(portal.getProperty("selectable_views"))
    layout = portal.getProperty("layout")

    plumi_homepage = "featured_videos_homepage"

    if layout and layout is plumi_homepage:
        portal.manage_changeProperties(**{"layout" : 'folder_listing'})

    if plumi_homepage is current:
        plone.setLayout('folder_listing')
        plone.manage_changeProperties(**{"default_view" : 'folder_listing'})
        out.write("Plumi Homepage is no longer the portal's default view")

    if plumi_homepage in selectable:
        selectable.remove(plumi_homepage)
        portal.manage_changeProperties(**{"selectable_views" : selectable})
        out.write("Plumi Homepage option removed from the portal properties")
    
    if plumi_homepage in options:
        try:
            options.remove(plumi_homepage)
            plone.manage_changeProperties(**{"view_methods" : options})
            out.write("Plumi Homepage option removed from Plone Site "
                      "FTI views")
        except ValueError:
            pass

def addCatalogKeys(self, out):

    pc = getToolByName(self, 'portal_catalog')
    refresh = False
    index = pc.indexes()
    metadata = pc.schema()

    # Things to add to the catalog.
    keys = (dict(name = 'hasImageAndCaption',
                 meta = True,
                 idx  = False),)

    # Iter to add the things where they belong.
    for key in keys:

        name = key['name']
        if key['idx'] and name not in index:
            pc.addIndex(name, 'FieldIndex')
            out.write('Added %s index to portal_catalog\n' % name)
            refresh = True

        if key['meta'] and name not in metadata:
            pc.addColumn(name)
            refresh = True

    if refresh is True:
        pc.refreshCatalog()

    return refresh

def constructTagCloudObject(self, out):
    ''' Use Vaporisation and Portletification to mark a static tag cloud object '''
    tagcloud_id='tagcloud'
    try:
    	self.manage_delObjects(tagcloud_id)
    except:
	pass

    self.invokeFactory('VaporizedCloud', id=tagcloud_id, title=_(u'Tag Cloud'))
    tc = getattr(self,tagcloud_id)
    #update the static cloud
    tc._setTree()
    #portletifiy it on the right
    portletifiable = IPortletifiable(tc)
    portletifiable.portletify(position='right')
    publishObjectandOwnership(self,tc,USER['id'])
    out.write("created tag cloud and portletified it on the right hand side")

def install (self):
    out = StringIO ()
    try:
        from Products.PlumiSkin.config import DEPENDENCIES
    except:
        DEPENDENCIES = []
    portal = getToolByName(self,'portal_url').getPortalObject()
    quickinstaller = portal.portal_quickinstaller
    for dependency in DEPENDENCIES:
        print >> out, "Installing dependency %s:\n" % dependency
        quickinstaller.installProduct(dependency)
        get_transaction().commit(1)

    addCustomCSS(self)
    addCatalogKeys(self, out)
    setupSkin (self, out)
    installWorkflowScripts(self,out)
    installUser(self, out)
    updateSlots(self,out)
    installActionProviders(self,out)
    configureMembersNewsEventsFolders(self,out)
    installIndex(self,out)
    installMembersPublishEvents(self,out)
    installMemberPreferences(self,out)
    changeCalendarSiteProperties(self,out)
    createNewsAndEventsFolder(self,out)
    ChangeSiteNewsEventsLayout(self,out)
    changePloneLayout(self, out)
    constructTagCloudObject(self,out)
    addDefaultMemberSkeleton(self,out)
    migrateExistingMembers(self,out)
    setupSupplViews(self, out, SUPPL_VIEWS) 
    out.write ('Skin Installation completed.\n')
    # try to call a custom install method
    # in 'AppInstall.py' method 'install'
    try:
        install = ExternalMethod('temp','temp',PROJECTNAME+'.AppInstall', 'install')
    except:
        install = None

    if install:
        print >>out,'Custom Install:'
        res = install(self)
        if res:
            print >>out,res
        else:
            print >>out,'no output'
    else:
        print >>out,'no custom install'
    out.write ('Installation completed.\n')
    return out.getvalue()

def uninstall (self):
    out = StringIO ()

    removeSkin (self, out)
    restorePloneLayout(self, out)
    removeSupplViews(self, out, SUPPL_VIEWS)
    out.write ('Uninstallation completed.\n')
    return out.getvalue()
