from zope.component import adapter
from zope.app.container.interfaces import IObjectAddedEvent, IObjectModifiedEvent
from Products.CMFCore.WorkflowCore import WorkflowException

from Products.ATVideo.interfaces.content_markers import IEngageVideo
from Products.CMFCore.utils import getToolByName
from Products.ATContentTypes.interface import IATEvent,IATNewsItem

import re
ATNAME_PF_PATTERN = "\w+\.\d+-\d+-\d+.*"

@adapter(IEngageVideo, IObjectModifiedEvent)
def notifyModifiedVideo(obj ,event):
    workflow = getToolByName(obj,'portal_workflow')
    state = workflow.getInfoFor(obj,'review_state','')
    print "Im here %s in state (%s) with event %s " % (obj.Title(), state,  event)
    if state == 'published': 
        print "refresing the catalog"
        #if published, lets refresh the latest videos folder
        portal_url = getToolByName(obj, "portal_url")
        portal = portal_url.getPortalObject()
        latestvideos = getattr(portal,'latestvideos',None)
        if latestvideos is not None:
            latestvideos.reindexObject()
        #if published, and featured, lets refresh the featured videos folder
        #XXX we could check its actually featured but whateva
	featuredvideos = getattr(portal,'featured-videos',None)
	if featuredvideos is not None:
	    featuredvideos.reindexObject()

@adapter(IATNewsItem, IObjectModifiedEvent)
def notifyAddedNews(obj ,event):
    workflow = getToolByName(obj,'portal_workflow')
    state = workflow.getInfoFor(obj,'review_state','')
    print "Im here %s in state (%s) with event %s , id : %s" % (obj.Title(), state,  event, obj.getId())
    if not obj.Title() == '' and state == 'visible' and re.match(ATNAME_PF_PATTERN,obj.getId()) is None: 
    	try:
		workflow.doActionFor(obj, 'submit')
	except WorkflowException:
		pass

@adapter(IATEvent, IObjectModifiedEvent)
def notifyAddedEvent(obj ,event):
    workflow = getToolByName(obj,'portal_workflow')
    state = workflow.getInfoFor(obj,'review_state','')
    print "Im here %s in state (%s) with event %s , id : %s " % (obj.Title(), state,  event, obj.getId())
    #this pattern match is a grevious hack but in plone2.5 there are multiple events , on adding and editing??
    if not obj.Title() == '' and state == 'visible' and re.match(ATNAME_PF_PATTERN,obj.getId()) is None: 
    	try:
    		workflow.doActionFor(obj, 'submit')
	except WorkflowException:
		pass
