# -*- coding: utf-8 -*-

from zope.interface import implements
from BTrees.OOBTree import OOBTree
from zope.app.annotation.interfaces import IAnnotations
from Products.CMFCore.utils import getToolByName
from Products.Portletification.interfaces import IPortletifiable


class PortletifiableObject( object ):

    implements( IPortletifiable )

    def __init__(self, context):
        self.key         = 'portletification'
        self.context     = context
        self.annotations = IAnnotations(context)
        
        if not self.annotations.get(self.key, None):
            positions = OOBTree()
            positions['left'] = False
            positions['right'] = False
            self.annotations[self.key] = positions


    def portletified(self):
        portlet = self.annotations[self.key]
        return portlet


    def portletify(self, position):
        portlet = self.annotations[self.key]
        if position in portlet and portlet[position] is False:
            portlet[position] = True
            self.annotations[self.key] = portlet
            return True
        return False

    
    def unportletify(self, position):
        portlet = self.annotations[self.key]
        if position in portlet:
            portlet[position] = False
            self.annotations[self.key] = portlet
            return True
        return False
