# -*- coding: utf-8 -*-

from Products.CMFPlone.CatalogTool import registerIndexableAttribute
from Products.Portletification.interfaces import IPortlet
from Products.Portletification.interfaces import IPortletifiable
from zope.interface import providedBy
try:
    from zope.component.interface import interfaceToName
except ImportError:
    # BBB for Zope < 2.9
    def interfaceToName(context, interface):
        return interface.__module__ + '.' + interface.__name__


def object_implements(object, portal, **kw):
    return [interfaceToName(portal, i) for i in providedBy(object).flattened()]


def portletified(object, portal, **kw):
    
    if not IPortlet.providedBy(object):
        return list()
    
    portlet = IPortletifiable(object)
    positions = portlet.portletified()
    
    if not positions:
        return list()
    
    return [p for p in positions.keys() if positions[p] is True]


registerIndexableAttribute('object_implements', object_implements)
registerIndexableAttribute('portletified', portletified)

