# -*- coding: utf-8 -*-

__author__	= 'Souheil CHELFOUH <souheil@chelfouh.com>'
__docformat__	= 'plaintext'

from StringIO import StringIO

from Products.CMFCore.utils import getToolByName
from Products.CMFDynamicViewFTI.migrate import migrateFTIs

from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes
from Products.Archetypes.Extensions.utils import install_subskin

from Products.Vaporisation.config import *
from Products.Vaporisation.Extensions.utils import *


def install(self):
    """
    Install Vaporisation
    """
    out = StringIO()

    # Install types
    classes = listTypes(PROJECTNAME)
    installTypes(self, out,
                 classes,
                 PROJECTNAME)


    # Install skin
    install_subskin(self, out, product_globals)
    registerResources(self, out, 'portal_css', STYLESHEETS)
    registerResources(self, out, 'portal_javascripts', JAVASCRIPTS)


    # Migrate FTI, to make sure we get the necessary infrastructure for the
    # 'display' menu to work.
    migrated = migrateFTIs(self, product=PROJECTNAME)
    

    # Enable portal_factory
    if len(FACTORY):
        
        factory = getToolByName(self, 'portal_factory')
        types = factory.getFactoryTypes().keys()
        
        for myType in FACTORY:
            if myType not in types:
                types.append(myType)
                
        factory.manage_setPortalFactoryTypes(listOfTypeIds = types)


    # Hide types to navigation    
    portalProperties = getToolByName(self, 'portal_properties')
    navtreeProps = getattr(portalProperties, 'navtree_properties')
    siteProps = getattr(portalProperties, 'site_properties')

    if HIDDEN:
        addToListProperty(self, out, navtreeProps,
                          'metaTypesNotToList', HIDDEN)
        addToListProperty(self, out, siteProps,
                          'types_not_searched', HIDDEN)
        addToListProperty(self, out, navtreeProps,
                          'parentMetaTypesNotToQuery', HIDDEN)

    return out.getvalue()


def uninstall(self):
    out = StringIO()

    resetResources(self, out, 'portal_css', STYLESHEETS)
    resetResources(self, out, 'portal_javascripts', JAVASCRIPTS)

    return out.getvalue()
